
 ## Contributing to Office UI Fabric React

Please use the following steps to contribute a new component or a bug fix to the Office UI Fabric project.

* Setup your branch using instructions in [Git branch Setup](./Setup.md).

* Read [BugFix](./BugFixes.md) guide for preparing a bug fix and the [New Component](./NewComponent.md) guide for building a new component.

* Run `npm run change` and provide component details. Please read the [ChangeFiles](./ChangeFiles.md) document for more details on providing change instructions.

* Push the changes to your remote branch.

* Create a pull request against the **OfficeDev/office-ui-fabric-react** repository.

* Seek feedback from the **Fabric core team** about the bug fix or the new component. We are constantly reviewing and helping merge pull requests. In case of a bug fix make sure to seek feedback from the component owner specified in the [Code Owners](../../.github/CODEOWNERS) file by tagging them on the pull request.

* Once feedback is received, make sure all tests are passing. Add new tests when applicable.

* Complete the pull request.