const path = require('path');
const resources = require('../../scripts/tasks/webpack-resources');

const BUNDLE_NAME = 'experiments';
const IS_PRODUCTION = process.argv.indexOf('--production') > -1;

module.exports = resources.createConfig(
  BUNDLE_NAME,
  IS_PRODUCTION,
  {
    entry: {
      [BUNDLE_NAME]: './lib/index.js'
    },

    output: {
      libraryTarget: 'var',
      library: 'FabricExperiments'
    },

    externals: [
      { 'react': 'React' },
      { 'react-dom': 'ReactDOM' }
    ],

    resolve: {
      alias: {
        '@uifabric/experiments/src': path.join(__dirname, 'src'),
        '@uifabric/experiments/lib': path.join(__dirname, 'lib')
      }
    }
  }
);
